Unit Lonely;

// Apollo Developments (Prop: Andy Preston) Swindon U.K. apollod@yahoo.com

// Limiting Delphi 2, 3?, & 4? Applications to a single instance

// Based on Brendan Delumpa's PrevInst.dpr and PrevCode.pas which I obtained from an archive
// compiled by greglief@objectlessons.com.

// Use this code freely in your own applications, but don't blame us if you break something
// it is supplied 'As is'. If you find a way of making it better then drop us an E-Mail.

Interface

// If you only need to know, if your app is already running use the AlreadyRunning Function
// it simply checks for a previous instance, & does nothing else. Brendan's original, also
// brought the previos instance's window up.

Function AlreadyRunning : Boolean;

// This procedure will actually terminate the current isntance, if there is a revious instance
// If ShowMessage is True a simple message will be displayed first, if ShowOther is True
// The other instance's main window will be brought up.

Procedure TerminateIfAlreadyRunning (ShowMessage, ShowOther : Boolean);

Implementation

// If you don't want to use my message box routine: DisplayMessage, loose the DispMsg reference
// below, & change the DisplayMessage line to something more tradditional.

Uses
  Windows, Forms, DispMsg;

Procedure TerminateIfAlreadyRunning (ShowMessage, ShowOther : Boolean);
Var
  Wind : HWnd;
  FindTitle : PChar;
Begin
  If AlreadyRunning Then Begin
    If ShowMessage Then
      DisplayMessage ('Already Running', Application.Title+#13'is already running', mdtError);
    If ShowOther Then Begin
      FindTitle:=PChar (Application.MainForm.Caption);
      Application.MainForm.Caption:='AdTiar';
      Wind:=FindWindow (Nil, FindTitle);
      If Wind<>0 Then Begin
        ShowWindow (Wind, SW_SHOW);
        SetForegroundWindow (Wind);
      End;
    End;
    Application.Terminate;
  End;
End;

Function AlreadyRunning : Boolean;
Var
  Sem  : THandle;
Begin
  Sem:=CreateSemaphore (Nil, 0, 1, 'AdArSem');
  Result:=(Sem<>0) And (GetLastError=ERROR_ALREADY_EXISTS);
  If Result Then CloseHandle (Sem);
End;

End.
